﻿/*
 * Przykładowy operator - suma arytmetyczna, logiczna i złączenie tekstów
 */
// przestrzeń nazw "własny typ Variant"
namespace CustomVariant
{
  // klasa Variant
  public partial class Variant
  {
    // operator dodawania
    public static Variant operator +(Variant x1, Variant x2)
    {
      // Jeżeli pierwszy parametr jest int sumuj arytmetycznie
      // x1 narzuca typ pozostałych składników, tu: int
      if (x1.r.t == VariantType.isInt)
      {
        return new Variant(x1.AsInt + x2.AsInt);
      }
      // Jeżeli pierwszy parametr jest bool sumuj logicznie
      // x1 narzuca typ pozostałych składników, tu: bool
      else if (x1.r.t == VariantType.isBool)
      {
        return new Variant(x1.AsBool || x2.AsBool);
      }
      // Jeżeli pierwszy parametr jest string złącz teksty
      // x1 narzuca typ pozostałych składników, tu: string
      else
      {
        return new Variant(x1.AsStr + x2.AsStr);
      }
    }

    // operator dodawania do wartości int
    public static Variant operator +(int x1, Variant x2)
    {
      return (new Variant(x1)) + x2;
    }

    // operator dodawania do wartości bool
    public static Variant operator +(bool x1, Variant x2)
    {
      return (new Variant(x1)) + x2;
    }

    // operator dodawania do wartości string
    public static Variant operator +(string x1, Variant x2)
    {
      return (new Variant(x1)) + x2;
    }
  }
}