﻿/*
 * Własności prywatne do konwersji typów
 */
using System;

// przestrzeń nazw "własny typ Variant"
namespace CustomVariant
{
  // klasa Variant
  public partial class Variant
  {
    // prywatna własność tylko do odczytu jako wartość całkowita
    private int AsInt
    {
      get
      {
        if (isAssigned)                   // jeżeli wartość jest podstawiona:
        {
          if (r.t == VariantType.isInt)   // jeżeli jest int: 
          {                               // zwróć pole i
            return r.i;
          }
          if (r.t == VariantType.isBool)  // jeżeli jest bool: 
          {
            if (r.b == false)             // jeżeli b jest false
            {                             // zwróć zero
              return 0;
            }
            else                          // jeżeli b jest true
            {                             // zwróć jeden
              return 1;
            }
          }
          else                            // jeżeli jest string:
          {
            int v;

            if (int.TryParse(r.s, out v)) // jeżeli s reprezentuje
            {                             // odpowiednik tekstowy wartości int
              return v;                   // zwróć rezultat operacji int.Parse
            }
            else // jeżeli s nie reprezentuje odpowiednika tekstowgo wartości int
            {    // wywołaj wyjątek
              throw new Exception("Błąd rzutowania typu string na int");
            }
          }
        }
        else
        {
          return 0;                       // jeżeli wartość nie jest podstawiona:
        }                                 // zwróć zero
      }
    }

    // prywatna własność tylko do odczytu jako wartość logiczna
    private bool AsBool
    {
      get
      {
        if (isAssigned)                       // jeżeli wartość jest podstawiona:
        {
          if (r.t == VariantType.isInt)       // jeżeli jest int:
          {
            if (r.i == 0)                     // jeżeli i jest zero
            {                                 // zwróć false
              return false;
            }
            else                              // jeżeli i jest różne od zera
            {                                 // zwróć true
              return true;
            }
          }
          else if (r.t == VariantType.isBool) // jeżeli jest bool:
          {                                   // zwróć pole b
            return r.b;
          }
          else                                // jeżeli jest string:
          {
            bool v;

            if (bool.TryParse(r.s, out v))    // jeżeli s reprezentuje
            {                                 // odpowiednik tekstowy wartości bool
              return v;                       // zwróć rezultat operacji bool.Parse
            }
            else // jeżeli s nie reprezentuje odpowiednika tekstowgo wartości bool
            {    // wywołaj wyjątek
              throw new Exception("Błąd rzutowania typu string na bool");
            }
          }
        }
        else                                  // jeżeli wartość nie jest podstawiona:
        {                                     // zwróć false
          return false;
        }
      }
    }

    // prywatna własność tylko do odczytu jako wartość tekstowa
    private string AsStr
    {
      get
      {
        if (isAssigned)                       // jeżeli wartość jest podstawiona:
        {
          if (r.t == VariantType.isInt)       // jeżeli jest int:
          {                                   // zwróć i w postaci string
            return r.i.ToString();            // np. -10, 0, 23 jako string
          }
          else if (r.t == VariantType.isBool) // jeżeli jest bool:
          {                                   // zwróć b w postaci string
            return r.b.ToString();            // tylko False lub True
          }
          else                                // jeżeli jest string:
          {                                   // zwróć s
            return r.s;
          }
        }
        else                                  // jeżeli wartość nie jest podstawiona:
        {                                     // zwróć pusty string
          return "";
        }
      }
    }
  }
}